import math;
import hyperbolic_geometry;

size(500,500);
settings.outformat="pdf";

// What do we want to test?
// The theorem of Thales does not hold in the hyperbolic plane

hyperbolic_point A = hyperbolic_point(0.8,35);
hyperbolic_point B = hyperbolic_point(1.2,140);

hyperbolic_point M = midpoint(A,B);

hyperbolic_line L = hyperbolic_line(A,B);

hyperbolic_circle C = hyperbolic_circle(M,A);

hyperbolic_point[] E;
hyperbolic_segment[] S;
hyperbolic_segment[] T;
string s;
int imax = 10;
for(int i = 1; i < imax; ++i) {
    E[i-1] = rotate(M, A, 180/imax*i);
    S[i-1] = hyperbolic_segment(A,E[i-1]);
    T[i-1] = hyperbolic_segment(B,E[i-1]);
    s = string(degrees(angle(A,E[i-1],B)),4);
    label(s,E[i-1].get_euclidean());
}

draw(L, blue);
draw(C, blue);
draw(S, yellow);
draw(T, yellow);
dot(A, blue);
dot(B, blue);
dot(M, black);
dot(E, gray);

draw((1,1)--(1,-1)--(-1,-1)--(-1,1)--cycle);
draw(unitcircle);
